#!ruby
# -*- mode: ruby; coding: utf-8 -*-
# Last updated: <2016/11/16 22:37:29 +0900>
#
# rsvg-convert を使って svgファイル群をpngに変換するスクリプト
#
# rsvg-convert が必要。以下の版を使わせてもらった。
#
# Open Source Software and Windows 32-bit: RSVG-Convert SVG image conversion tool
# http://opensourcepack.blogspot.com/2012/06/rsvg-convert-svg-image-conversion-tool.html
#
# 動作確認環境 : Windows10 x64 + Ruby 2.2.5 p319 i386-mingw32

src_dir = 'scalable'

dir_list = [
  ['16x16', '--format=png -w 16 -h 16'],
  ['22x22', '--format=png -w 22 -h 22'],
  ['32x32', '--format=png -w 32 -h 32'],
  ['scalable', '--format=png']
]

def join_filepath(d, f)
  return File.join(d, f).gsub(File::SEPARATOR,
                              File::ALT_SEPARATOR || File::SEPARATOR)
end

Dir.foreach(src_dir) do |fn|
  next if fn =~ /^\.{1,2}$/
  next unless fn =~ /\.svg$/
  dir_list.each do |d|
    dn, opt = d
    src = join_filepath(src_dir, fn)
    dst = join_filepath(dn, File.basename(fn, '.svg') + '.png')
    execstr = "rsvg-convert #{src} -o #{dst} #{opt}"
    puts execstr
    system(execstr)
  end
end
